VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SWTraverse_invisible by Mike Dejanovic v0.2/02-07-2002"
   ClientHeight    =   3195
   ClientLeft      =   2235
   ClientTop       =   1785
   ClientWidth     =   5940
   Icon            =   "traverseassembly.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   5940
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   2820
      TabIndex        =   6
      Top             =   2760
      Width           =   1215
   End
   Begin VB.FileListBox File1 
      Height          =   1260
      Left            =   60
      Pattern         =   "*.sldasm"
      TabIndex        =   5
      Top             =   1440
      Width           =   2775
   End
   Begin VB.DirListBox Dir1 
      Height          =   990
      Left            =   60
      TabIndex        =   4
      Top             =   420
      Width           =   2715
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   60
      TabIndex        =   3
      Top             =   60
      Width           =   2715
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Exit"
      Height          =   435
      Left            =   60
      TabIndex        =   2
      Top             =   2760
      Width           =   975
   End
   Begin VB.ListBox List1 
      Height          =   2595
      Left            =   2820
      TabIndex        =   1
      Top             =   60
      Width           =   3075
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Traverse Assembly"
      Height          =   435
      Left            =   4260
      TabIndex        =   0
      Top             =   2760
      Width           =   1635
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Function TraverseComponent(Level As Integer, Component As Object)

' Recursive routine to traverse all the children of a component
 Dim Text As String
 Dim tmp_str As String
 Dim gettxt As String * 254
 Dim gettxt1 As String
 Dim I As Integer
 Dim y As Long
 Dim yy As Integer
 Dim tnx As Long
 Dim Children As Variant
 Dim Child As Object
 Dim ChildCount As Integer
 
' Perform component specific operations...
' In this case Output the components name (to the debug window)
 For I = 1 To Level
  Text = Text + " "   ' indent the output string
 Next I
  Text = Text + Component.Name  ' Add the name of the component
  tmp_str = Trim(Component.Name)
  If Len(tmp_str) > 2 Then
    tmp_str = Mid$(tmp_str, 1, Len(tmp_str) - 2)
  End If
 'Debug.Print Text    ' Display in the Visual Basic Debug Window
' Text1.Text = Text1.Text + Text
 'mike start
 If Trim(tmp_str) <> "" Then

    y = SendMessage(List1.hwnd, LB_FINDSTRING, 0, ByVal tmp_str)
    If y < 0 Then 'Not Found
    If Text1.Text = "" Then
       List1.AddItem tmp_str + "->0001"
    Else
    'Text1.Text = Trim(Text1.Text)
        If Mid$(Trim(tmp_str), 1, Len(Text1.Text)) = Trim(Text1.Text) Then
            List1.AddItem tmp_str + "->0001"
        End If
    End If
    Else
        yy = SendMessage(List1.hwnd, LB_GETTEXT, y, ByVal gettxt)
        gettxt1 = Left$(gettxt, yy)
        broj = Val(Right(gettxt1, 4))
        broj = broj + 1
        partname = Mid$(gettxt1, 1, yy - 4)
        List1.RemoveItem y ' y=item index
    Select Case Trim(Len(Str(broj))) - 1
        Case 1
            broj = "000" + Trim(Str(broj))
        Case 2
            broj = "00" + Trim(Str(broj))
        Case 3
            broj = "0" + Trim(Str(broj))
        Case 4
        broj = Trim(Str(broj))
    End Select
    
        List1.AddItem (partname + broj), y
    End If
 End If

 'mike end
 'Traverse the children
Children = Component.GetChildren ' Get the list of children
' Get the # of elements in the variant safearray. UBound returns the
' upper element number. Since the array begins at zero, we must add 1
' to get the actual number of array elements. If no elements are
' in the array, then UBound returns -1.
ChildCount = UBound(Children) + 1
For I = 0 To (ChildCount - 1) ' For each Child in this subassembly
    Set Child = Children(I)   ' Get Child component object
    TraverseComponent Level + 1, Child ' Traverse the child's components
Next I
End Function

Private Sub Command1_Click()
List1.Clear
 
 Dim swApp As Object
 Dim AssemblyDoc As Object
 Dim AssemblyDoc_file As Object
 Dim Configuration As Object
 Dim RootComponent As Object
 Dim asm_path As String
 
 Const swDocASSEMBLY = 2
 Dim longstatus As Long

 Set swApp = CreateObject("SldWorks.Application")
 swApp.Visible = False
'we have to set the asm doc not the current one so LOAD it
asm_path = Dir1 + "\" + File1.FileName
If asm_path = "" Then
    MsgBox "Could not load ASM file (not available or so)"
    Exit Sub
End If
Set AssemblyDoc_file = swApp.OpenDoc4(asm_path, swDocASSEMBLY, &H1, "", longstatus)
DoEvents
Set AssemblyDoc = swApp.ActiveDoc ' Current document
 ' Find the Root Component
 Set Configuration = AssemblyDoc.GetActiveConfiguration()
 Set RootComponent = Configuration.GetRootComponent()
 ' Recursively traverse the component

 If Not RootComponent Is Nothing Then
  TraverseComponent 1, RootComponent
 End If
 'swApp.UserControl = True 'enable this to make sw window visible and to allow user to shut it donw or not
 Set RootComponent = Nothing
 Set Configuration = Nothing
 Set AssemblyDoc = Nothing
 Set AssemblyDoc_file = Nothing
 Set swApp = Nothing
End Sub

Private Sub Command2_Click()
End

End Sub

Private Sub Command3_Click()
MsgBox Dir1 + "\" + File1.FileName
End Sub

Private Sub Dir1_Change()
File1.Path = Dir1
End Sub

Private Sub Drive1_Change()
 Dir1.Path = Drive1
End Sub

Private Sub Form_Resize()
If Form1.Height > 1400 Then
List1.Width = Form1.Width - 95
Command1.Top = Form1.Height - 855
If Form1.Width > 4900 Then
    Command1.Left = Form1.Width - 1800
End If
Command2.Top = Form1.Height - 855
'Command3.Top = Form1.Height - 855
Text1.Top = Form1.Height - 855
If Form1.Height > 886 Then
List1.Height = Form1.Height - 885
End If
End If
End Sub

Private Sub Text1_KeyPress(KeyAscii As Integer)
If KeyAscii = 13 Then
Command1_Click
End If
End Sub
